]> git.phdru.name Git - dotfiles.git/blob - .shellrc
.shellrc: delegate completion for `p` as for `ping`
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60
61 OPS1="$OPS1\\$"
62 PS1="$OPS1 "
63
64
65 if test -n "$BASH_VERSION"; then
66    [ "`type -t ls`" = alias ] && unalias ls
67    [ "`type -t ll`" = alias ] && unalias ll
68    [ "`type -t mc`" = alias ] && unalias mc
69
70    back() { cd - "$@"; }
71    functions() { typeset -f "$@"; }
72    j() { jobs; }
73
74    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
75       if [ "$SHELL" = /bin/bash ]; then
76          if [ -f /etc/bash_completion ]; then
77             . /etc/bash_completion
78          elif [ -d /etc/bash_completion.d ]; then
79             . /etc/bash_completion.d/*
80          fi
81       elif [ "$SHELL" = /usr/local/bin/bash ]; then
82          if [ -d /usr/local/etc/bash_completion.d ]; then
83             . /usr/local/etc/bash_completion.d/*
84          fi
85       else
86          echo "Unknown OS type, canot source bash_completion" >&2
87       fi
88    fi
89
90    has_completion() { return 0; }
91    if [ "$SHELL" = /bin/bash ]; then
92       if [ -d /etc/bash_completion.d -o -d /usr/share/bash-completion/completions ]; then
93          has_completion() { [ -r /etc/bash_completion.d/$1 -o -r /usr/share/bash-completion/completions/$1 ]; }
94       fi
95    elif [ "$SHELL" = /usr/local/bin/bash ]; then
96       if [ -d /usr/local/etc/bash_completion.d ]; then
97          has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
98       fi
99    fi
100
101    for cmd in builtin cgmem_nice command dbus-launch exec \
102       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
103       time whence whereis which xargs; do
104          ! has_completion $cmd && complete -o default -A command $cmd
105    done
106
107    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
108       telnet t tt \
109       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
110       whois wget wget-m wget-wrapper ww; do
111          ! has_completion $cmd && complete -A hostname $cmd
112    done
113
114    for cmd in distribute ftp lftp r rsync \
115       s scp ssh smbclient tcpdump tshark wireshark; do
116          ! has_completion $cmd && complete -o default -A hostname $cmd;
117    done
118
119    delegate_completion() {
120       local prog completion_f programs
121       prog="$1"
122       completion_f="$2"
123       shift; shift
124       programs="$@"
125       if has_completion "$prog"; then
126          eval "_${prog}_completion_loader() {
127             _completion_loader $prog
128             complete -F $completion_f $programs
129             unset _${prog}_completion_loader
130             return 124
131          }"
132          complete -F _"$prog"_completion_loader $programs
133       fi
134    }
135
136    delegate_completion make _make m
137    delegate_completion ping _ping p
138    delegate_completion rsync _rsync r
139    delegate_completion ssh _ssh s
140    delegate_completion wget _wget wget-m wget-wrapper ww
141
142    unset has_completion delegate_completion
143
144    complete -A job bg fg j jobs wait
145    complete -A variable -A function unset
146
147    if [ -d "$HOME/lib/config" ]; then
148       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
149    fi
150    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
151
152    #if type -p pip >/dev/null 2>&1; then
153    #   eval "`pip completion --bash`"
154    #   rm -rf /tmp/pip_build_"$USER"
155    #fi
156
157 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
158    back() { cd - "$@"; }
159    j() { jobs; }
160 fi
161
162
163 # clear screen and history, logout
164 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
165
166
167 if test -x /usr/bin/git >/dev/null 2>&1; then
168    # chdir to a remote's directory (if the remote is on the local FS)
169    cdremote() {
170       if [ -z "$1" -o -n "$2" ]; then
171          echo "Usage: cdremote remote_name" >&2
172          return 1
173       fi
174       cd "`git config --get remote.$1.url`"
175    }
176
177    if test -n "$BASH_VERSION"; then
178       # completion for global aliases in .gitconfig
179
180       # fixup rbi rbia rbiap rbip - do refs name completion
181       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
182       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
183       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
184       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
185       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
186       #
187       # push-to-all-remotes - do branch name completion
188       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
189
190       # list remotes with URLs matching a regexp
191       _list_remotes() {
192          if [ -z "$1" -o -n "$2" ]; then
193             echo "Usage: _list_remotes remote_regexp" >&2
194             return 1
195          fi
196          GIT_REMOTES=""
197          local remote
198          for remote in `git remote`; do
199             if git config --get remote.$remote.url | grep -q "$1"; then
200                GIT_REMOTES="$GIT_REMOTES $remote"
201             fi
202          done
203       }
204
205       # completion for cdremote and git-open - list remotes with a pattern
206       _list_remotes_completion() {
207          local cur="${COMP_WORDS[COMP_CWORD]}";
208          _list_remotes "$1"
209          COMPREPLY=(`compgen -W "$GIT_REMOTES" -- "$cur"`)
210          unset GIT_REMOTES
211       }
212
213       # completion for cdremote - list remotes with directories as URLs
214       _cdremote_complete() {
215          _list_remotes_completion '^\(/\|\.\./\)' # (/ or ../ at the beginning)
216       }
217
218       complete -F _cdremote_complete cdremote
219
220       # completion for git-open - list remotes with http(s) URLs
221       _git_open() {
222          _list_remotes_completion '^http\(s\)\?://'
223       }
224
225       complete -F _git_open git-open
226    fi
227 fi
228
229
230 include() {
231    cfg="$1"
232    if [ -f "./$cfg" -a -r "./$cfg" ]; then
233       echo "Reading config file \`$cfg'" 1>&2
234       . "./$cfg"
235    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
236       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
237       . "$HOME/lib/config/$cfg"
238    else
239       echo "Cannot find config file \`$cfg'" 1>&2
240    fi
241 }
242
243
244 mc() {
245    if test -n "$BASH_VERSION"; then
246       MC_SAVE_OPS1="$OPS1"
247       OPS1="\u@\h "
248    fi
249
250    if [ -n "$SLOWTERM" ]; then
251       MC_SLOW="--slow"
252    fi
253
254    case "$TERM" in
255       screen*) # screen, screen.rxvt
256          if [ "$TERM" = screen.rxvt ]; then
257             MC_SAVE_TERM="$TERM"
258             TERM=rxvt
259          fi
260          MC_XTERM="-x"
261       ;;
262    esac
263
264    #TMPDIR="$HOME"/tmp
265    #export TMPDIR
266
267    MC_FOUND=NO
268
269    for wrapper in \
270          /usr/local/share/mc/bin/mc-wrapper.sh \
271          /usr/local/libexec/mc/mc-wrapper.sh \
272          /usr/share/mc/bin/mc-wrapper.sh; do
273       if [ -r $wrapper ]; then
274          . $wrapper $MC_SLOW $MC_XTERM "$@"
275          rc=$?
276          MC_FOUND=YES
277          break
278       fi
279    done
280
281    if [ $MC_FOUND = NO ]; then
282       for mc in /usr/local/bin/mc /usr/bin/mc; do
283          if [ -x $mc ]; then
284             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
285             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
286                MC_TMP_DIR="${TMPDIR-/tmp}"
287             fi
288             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
289             mc_type="`mc_type.py $mc`"
290             if [ "$mc_type" = old ]; then
291                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
292             elif [ "$mc_type" = new ]; then
293                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
294             else
295                continue
296             fi
297             rc=$?
298             MC_FOUND=YES
299             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
300             break
301          fi
302       done
303    fi
304
305    if [ $MC_FOUND = NO ]; then
306       echo "Cannot find mc-wrapper.sh or mc" >&2
307       rc=1
308    fi
309
310    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
311    [ -n "$MC_SAVE_TERM" ] && TERM="$MC_SAVE_TERM"
312    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SAVE_TERM \
313          MC_SLOW MC_TMP_DIR MC_XTERM
314
315    return $rc
316 }
317
318
319 mkcd() {
320    if [ $# -ne 1 ]; then
321       echo "Usage: mkcd directory_name" >&2
322    elif [ -d "$1" ]; then
323       cd "$1"
324    elif [ -e "$1" ]; then
325       echo "Error: $1 is a file" >&2
326    else
327       mkdir -p "$1" && cd "$1"
328    fi
329 }
330
331
332 if which tmux >/dev/null 2>&1; then
333    tmux() {
334       case "$TERM" in
335          rxvt)
336             TERM=rxvt-unicode command tmux "$@"
337          ;;
338
339          *)
340             command tmux "$@"
341          ;;
342       esac
343    }
344 fi
345
346
347 #if which pyenv >/dev/null 2>&1; then
348 #   eval "`pyenv init -`"
349 #   eval "`pyenv virtualenv-init -`"
350 #fi
351
352 source virtualenvwrapper_lazy.sh 2>/dev/null
353
354 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
355    X() { startx >> .Xserver.log 2>&1; cyr; }
356 fi
357
358 x() { exit; }